﻿using System;
using System.Collections.Generic;
using System.Drawing;

namespace CutsceneEditor
{
    public class Animation
    {
        public string Name { get; private set; }

        public ImageSequence ImageSequence { get; private set; }

        private int mIdxCurFrame;
        public Image CurrentFrame { get { return ImageSequence[mIdxCurFrame]; } }

        public int FrameDuration { get; set; }
        private int mFrameTime;
        private int mSpeed;

        public bool IsFlipped { get; set; }

        public Animation(string name, ImageSequence imageSequence)
        {
            Name = name;

            ImageSequence = imageSequence;

            mIdxCurFrame = 0;

            FrameDuration = 1;
            mFrameTime = 0;
            mSpeed = 0;

            IsFlipped = false;
        }

        public void Start()
        {
            mSpeed = 1;
        }

        public void Stop()
        {
            mSpeed = 0;
        }

        public void OnTick()
        {
            mFrameTime += mSpeed;
            if (mFrameTime > FrameDuration)
            {
                mIdxCurFrame = (mIdxCurFrame + 1) % ImageSequence.NumImages;
                mFrameTime = 0;
            }
        }
    }
}
