﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;
using System.Reflection;
using System.IO;

namespace CutsceneEditor
{
    public partial class RenderOptionsDialog : Form
    {
        public RenderOptionsDialog()
        {
            InitializeComponent();

            mNbHeight.ValueChanged += new EventHandler(mNbHeight_ValueChanged);
            mNbWidth.ValueChanged += new EventHandler(mNbWidth_ValueChanged);

            Assembly executable = Assembly.GetExecutingAssembly();
            DirectoryInfo rootDir = new DirectoryInfo(Path.GetDirectoryName(executable.Location));
            Filename = Path.Combine(rootDir.FullName, "Cutscene.gif");
        }

        private void mNbHeight_ValueChanged(object sender, EventArgs e)
        {
            mNbWidth.Value = mNbHeight.Value * 8;
        }

        private void mNbWidth_ValueChanged(object sender, EventArgs e)
        {
            decimal maxWidth = mNbHeight.Value * 8;
            if (mNbWidth.Value > maxWidth)
            {
                mNbWidth.Value = maxWidth;
            }
        }

        public string Filename
        {
            get { return mTbFilename.Text; }
            set { mTbFilename.Text = value; }
        }

        public int ImageHeight
        {
            get { return (int)mNbHeight.Value; }
            set 
            { 
                mNbHeight.Value = (decimal)value;
                mNbWidth.Value = mNbHeight.Value * 8;
            }
        }

        public int ImageWidth
        {
            get { return (int)mNbWidth.Value; }
        }

        public int FramesPerSecond
        {
            get { return (int)mNbFrameRate.Value; }
            set { mNbFrameRate.Value = (decimal)value; }
        }

        public int MaxDurationSec
        {
            get { return (int)mNbMaxDuration.Value; }
            set { mNbMaxDuration.Value = (decimal)value; }
        }

        private void mBtFilename_Click(object sender, EventArgs e)
        {
            mSfdImage.InitialDirectory = Path.GetDirectoryName(Filename);
            mSfdImage.FileName = Filename;
            if (mSfdImage.ShowDialog() == DialogResult.OK)
            {
                Filename = mSfdImage.FileName;
            }
        }
    }
}
