grammar Actor;

// Parser rules
actor: properties? animations;

properties: propertyColorR? propertyColorG? propertyColorB?;
propertyColorR: 'colorR' '=' Digit ';';
propertyColorG: 'colorG' '=' Digit ';';
propertyColorB: 'colorB' '=' Digit ';';

animations: 'animations' '=' '{' animation* '}';
animation: Name '=' '{' (flippedAnimation | animationFrames) '}';
flippedAnimation: 'flipped_x;' animationFrames;

animationFrames: 'images' '=' '[' frames* '];';
frames: frame | (frame ',');
frame: Name;

// Lexer rules
fragment NonZeroDigit : [1-9];
fragment Digits : [0-9];
Digit : '0' | NonZeroDigit Digits*;

fragment Letter : [a-zA-Z_];
fragment LetterOrDigit : [a-zA-Z0-9_.];
Name : Letter LetterOrDigit*;

Whitespace : [ \t\r\n]+ -> skip;