grammar Cutscene;

// Parser rules
cutscene: cutsceneBody*;
cutsceneBody: routine | LineComment;

routine: 'routine' Identifier '{' routineBody* '}';

routineBody : terminatedStatement | LineComment;
terminatedStatement : statement ';';

statement
	: 'StartRoutine' Identifier						# Statement_StartRoutine
	| 'Wait' Digit									# Statement_Wait
	| 'Wait' Digit Digit							# Statement_WaitSec
	| 'CreateActor' Identifier String				# Statement_CreateActor
	| 'CreateActor' Identifier String Digit Digit	# Statement_CreateActorMoveActor
	| 'MoveActor' Identifier Digit Digit			# Statement_MoveActor
	| 'WalkActor' Identifier Digit					# Statement_WalkActor
	| 'WalkActor' Identifier Digit Digit			# Statement_WalkActorXY
	| 'StartAnimActor' Identifier Identifier		# Statement_StartAnimActor
	| 'ShowActorText' Identifier String Digit		# Statement_ShowActorText
	| 'ShowActorText' Identifier String Digit Digit	# Statement_ShowActorTextSec
	| 'ShowText' String Digit						# Statement_ShowText
	| 'ShowText' String Digit Digit					# Statement_ShowTextSec
	| 'Yield'										# Statement_Yield
	;

// Lexer rules
fragment NonZeroDigit : [1-9];
fragment Digits : [0-9];
Digit : '0' | NonZeroDigit Digits*;

fragment Letter : [a-zA-Z$_];
fragment LetterOrDigit : [a-zA-Z0-9$_];

Identifier : Letter LetterOrDigit*;

String : '"' StringCharacters? '"';
fragment StringCharacters : StringCharacter+ ;
fragment StringCharacter : ~['\\\r\n];

Whitespace : [ \t\r\n]+ -> skip;

LineComment : '//' ~[\r\n]* -> skip;