﻿using System;
using Antlr4.Runtime;
using Antlr4.Runtime.Tree;

namespace CutsceneGrammar
{
    public static class CutsceneGrammar
    {
        public static void ParseCutscene(string cutscene, ICutsceneListener listener)
        {
            AntlrInputStream input = new AntlrInputStream(cutscene);

            CutsceneLexer lexer = new CutsceneLexer(input);
            CommonTokenStream tokens = new CommonTokenStream(lexer);

            CutsceneParser parser = new CutsceneParser(tokens);
            IParseTree tree = parser.cutscene();

            ParseTreeWalker walker = new ParseTreeWalker();
            walker.Walk(listener, tree);
        }

        public static void ParseActor(string actor, IActorListener listener)
        {
            AntlrInputStream input = new AntlrInputStream(actor);

            CutsceneLexer lexer = new CutsceneLexer(input);
            CommonTokenStream tokens = new CommonTokenStream(lexer);

            ActorParser parser = new ActorParser(tokens);
            IParseTree tree = parser.actor();

            ParseTreeWalker walker = new ParseTreeWalker();
            walker.Walk(listener, tree);
        }
    }
}
